public class Main{

	public static void main(String[] args){
		// Sowohl Klasse als auch Klasse2 sind Auspraegungen der
		// Schnittstelle 'InterfaceBsp' und koennen dager
		// polymorph verwendet werden.
		InterfaceBsp bsp = new Klasse();
		useInterfaceBsp(bsp);

		bsp = new Klasse2();
		useInterfaceBsp(bsp);
	}

	// Die Methode erwartet den Typ 'InterfaceBsp'
	// -> Es kann jede Klasse, die Auspraegung dieser
	// Schnittstelle ist uebergeben werden!
	private static void useInterfaceBsp(InterfaceBsp bsp){
		// Es werden nur Methoden aus der Schnittstelle aufgerufen,
		// da nur diese definiert sind fuer alle Auspraegungen.
		bsp.m1();
		bsp.m2();
		System.out.println("Return value: "+bsp.m3());		
	}
}
